## YAP Prolog Library {#library}



 YAP supports
 the library_directory path (set by the
  `LIBDIR` variable in the Makefile for YAP). Several files in the
  library are originally from the public-domain Edinburgh Prolog library.

1. Data Structures
  + @ref args Term Argument Manipulation.
  + @ref macros Apply Interface to maplist.
    + ApplyMaplist Apply Stub for maplist Predicates
  + @ref Assoc Association Maps
  + @ref avl AVL Trees
  + @ref bhash Backtrackable Hash Tables
  + @ref graphs Directed Graphs
  + @ref rltrees Range-List Trees
  + @ref rbtrees Red-Black Trees
  + @ref matrix Matrix Library
  + @ref matlab MATLAB Package Interface
  + @ref nb Non-Backtrackable Data Structures
  + @ref ordsets Ordered Sets
  + @ref queues Queues

2. Execution
   + @ref block_diagram Block Diagram
   + @ref c_alarms Concurrent Alarms
   + @ref charsio Operations on Sequences of Codes.
   + @ref clauses Clause Manipulation
   + @ref cleanup Old Call Cleanup
   + @ref coinduction Co-Logic Programming
   + @ref dbusage Memory Usage in Prolog Data-Base
   + @ref LambdaLambda expressions
   + @ref lam_mpi MPI Interface
   + @ref line_utilsLine Manipulation Utilities
   + @ref lists List Predicates in the Prolog Library
   + @ref Log2MD Log Output of Tests in Markdown format.
   + @ref mapargs Apply a predicate to all  arguments of a term
   + @ref maplist Map List and Term Operations
   + @ref parameters Automating test generation
   + @ref random Random Number Generator
     + @ref prandom  Van Gelder Random Number Generator
     + @ref Pseudo_Random Pseudo Random Number Integer Generator
     + @ref Terms Utilities On Terms
  
3. Input/Output	
   + @ref readutil)  Reading Lines and Files
   + @ref SICStus compatible socket library
   + @ref operating_system_support   Operating System Functionality
   + @ref timeout Calls With Timeout

